//$Id: SQLLoadable.java,v 1.1.2.1 2003/11/30 12:31:13 oneovthafew Exp $
package net.sf.hibernate.persister;

/**
 * A class persister that supports queries expressed in the 
 * platform native SQL dialect
 * 
 * @see net.sf.hibernate.loader.SQLLoader
 * @author Gavin King, Max Andersen
 */
public interface SQLLoadable extends Loadable {

	/**
	 * Return the column alias names used to persist/query the numbered property of the class or a subclass (optional operation).
	 */
	public String[] getSubclassPropertyColumnAliases(String propertyName, String suffix);	

	/**
	 * All columns to select, when loading.
	 */
	public String selectFragment(String alias, String suffix);
	
}
